// I2C_scan.CPP
// ------------   Version 08.09.2001
//                Borland IDE C++ 3.1
//                bearbeitet: BBS WiLu, D.Schwarzer
//                --------------------------------------
//                Ziel-Hardware: SC12 mit I2C-Bausteinen

// Das Programm ermittelt alle I2C-Bausteine, die momentan
// funktionstchtig auf dem I2C-Bus arbeiten und gibt deren
// Adressen in einer Liste aus.


#include <stdio.h>
#include <dos.h>

static union  REGS  inregs;
static union  REGS  outregs;

// API-Funktionen des I2C-Busses
// -----------------------------

void i2c_init()
{
  inregs.h.ah = 0x80;
  int86(0xAA,&inregs,&outregs);
}
void i2c_release(void)
{
	inregs.h.ah = 0x84;
	inregs.h.al = 0;
	int86(0xAA,&inregs,&outregs);
}
int i2c_scan(int anfang, int ende)
{
	inregs.h.ah = 0x81;
	inregs.h.al = anfang & 0x00FF;
	inregs.h.cl = ende   & 0x00FF;
	int86(0xAA,&inregs,&outregs);
	return (int)outregs.h.al & 0x00FF;
}

// main ()
// Das Programm untersucht den I2C-Bus im gesamten Adrebereich
// auf angeschlossene I2C-Bausteine.

void main (void)
{
	int anfang=0x00, ende =0xFF, resultat, n=0;
	printf("\n\n");
	printf("  I2C_scan\n");
	printf("  --------\n");

	i2c_init();
	while(1)
	{
	  resultat = i2c_scan(anfang, ende);

	  if (resultat == -1) { printf("  Fehler auf dem Bus\n"); break;}
	  if (resultat ==  0) { printf("  keine (weiteren) Bauteine gefunden\n"); break;}
	  else { printf("  Baustein %d, Adresse %Xh\n",++n,resultat);
		 anfang = resultat+2;}
	}
	i2c_release();
	printf("  ---------------------------------------\n");
	printf("  Es arbeiten zZt.%.2d Bausteine am I2C-Bus\n",n);
	printf("  I2C_scan Ende\n");
}